//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "ScanThread.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(&UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall ScanThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall ScanThread::ScanThread(bool CreateSuspended)
	: TThread(CreateSuspended)
{
	FreeOnTerminate = true;

	m_dwFiles = 0;
	m_dwInfected = 0;
	m_dwVirCodeOffset = 0;
}
//---------------------------------------------------------------------------
void __fastcall ScanThread::Execute()
{
	NameThreadForDebugging("ScanThread");
	//---- Place thread code here ----

	try {
		ScanFiles(Form1->TargetPath->Text);

		Synchronize(ModifyScanBtn);
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	catch (...)
	{
		try
		{
			throw Exception("");
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall ScanThread::ModifyScanState()
{
	// ˻ Ȳ 
	Form1->TextFolder->Caption = MinimizeName(m_ustrFolder, Form1->Canvas, 340);
	Form1->TextFile->Caption = MinimizeName(m_ustrFileName, Form1->Canvas, 340);

	Form1->TotalFiles->Caption = m_dwFiles;
	Form1->InfectedFiles->Caption = m_dwInfected;
}
//---------------------------------------------------------------------------
void __fastcall ScanThread::ModifyScanBtn()
{
	// '˻' ư  
	Form1->StartScanBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall ScanThread::UpdateReport()
{

	TListItem *Item = Form1->Report->Items->Insert(Form1->Report->GetCount());
	Item->Caption = m_ustrFileName;
	Item->SubItems->Add(m_ustrFolder);
	Item->SubItems->Add("ġᰡ");

	Form1->m_VirCodeOffset.push_back(m_dwVirCodeOffset);
}
//---------------------------------------------------------------------------
void ScanThread::ScanFiles(UnicodeString ustrPath)
{
	//  ˻ ƾ
	TSearchRec sr;

	UnicodeString ustrFirst = ustrPath + "\\*";
	UnicodeString ustrSubFolder;
	UnicodeString ustrFile;

	if (FindFirst(ustrFirst, faAnyFile, sr) == 0) {
		do {
			//   ȣ
			if ((sr.Name != ".") && (sr.Name != "..") && (sr.Attr & faDirectory)) {
				ustrSubFolder = ustrPath + "\\" + sr.Name;

				ScanFiles(ustrSubFolder);
			}
			//  ...
			else {
				if ((sr.Name == ".") || (sr.Name == "..")) continue;
				m_ustrFolder = ustrPath;
				m_ustrFileName = sr.Name;
				m_dwFiles++;

				ustrFile = m_ustrFolder + "\\" + m_ustrFileName;

				// ̷ ˻
				ScanVirus(ustrFile);

				Synchronize(ModifyScanState);
			}

			Sleep(5);

		} while (FindNext(sr) == 0);

		FindClose(sr);
	}
}
//---------------------------------------------------------------------------
void ScanThread::ScanVirus(UnicodeString ustrFile)
{
	UnicodeString DbgMsg;
	DWORD dwVirCodeOffset = 0;

	// CreateFile()
	HANDLE hFile = CreateFile(ustrFile.t_str(), FILE_GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
								FILE_ATTRIBUTE_NORMAL, NULL);

	if (hFile == INVALID_HANDLE_VALUE) {
		DbgMsg = "CreateFile()  - " + ustrFile;
		OutputDebugString(DbgMsg.t_str());

		return ;
	}

	//  ˻
	if (IsExecutable(hFile) == FALSE) {
		if (hFile != NULL) CloseHandle(hFile);
		return ;
	}

	// ̸ ̷ ˻
	if (IsInfected(hFile, &dwVirCodeOffset) == TRUE) {
		// Ʈ ߰
		m_dwVirCodeOffset = dwVirCodeOffset;
		m_dwInfected++;

		Synchronize(UpdateReport);
	}

	if (hFile != NULL) CloseHandle(hFile);
}
//---------------------------------------------------------------------------
BOOL ScanThread::IsExecutable(HANDLE hFile)
{
	DWORD dwRead = 0;
	BOOL bResult = FALSE;
	BOOL bRead = FALSE;

	LPBYTE pHeader = new BYTE[0x10];	// 16 Ʈ Ҵ

	bRead = ReadFile(hFile, pHeader, 0x10, &dwRead, NULL);
	if ((bRead == FALSE) || (dwRead == 0))
		bResult = FALSE;
	else {
		// 'MZ' ñ״ ˻
		if ((pHeader[0x00] == 'M') && (pHeader[0x01] == 'Z'))
			bResult = TRUE;
		else
			bResult = FALSE;
	}

	if (pHeader != NULL) delete [] pHeader;

	SetFilePointer(hFile, 0, NULL, FILE_BEGIN);

	return bResult;
}
//---------------------------------------------------------------------------
BOOL ScanThread::IsInfected(HANDLE hFile, DWORD* pdwOffset)
{
	HANDLE hFileMap = NULL;
	LPBYTE pOffset = NULL;
	LPBYTE pCodeSectionOffset = NULL;
	INT nCodeSectionSize = 0;
	INT nFileSize = 0;

	BYTE VirPattern[0x50] = {
		0x2D, 0x00, 0x00, 0x00, 0x75, 0x73, 0x65, 0x73, 0x20, 0x77, 0x69, 0x6E,
		0x64, 0x6F, 0x77, 0x73, 0x3B, 0x20, 0x76, 0x61, 0x72, 0x20, 0x73, 0x63,
		0x3A, 0x61, 0x72, 0x72, 0x61, 0x79, 0x5B, 0x31, 0x2E, 0x2E, 0x32, 0x34,
		0x5D, 0x20, 0x6F, 0x66, 0x20, 0x73, 0x74, 0x72, 0x69, 0x6E, 0x67, 0x3D,
		0x28, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
		0x66, 0x75, 0x6E, 0x63, 0x74, 0x69, 0x6F, 0x6E, 0x20, 0x78, 0x28, 0x73,
		0x3A, 0x73, 0x74, 0x72, 0x69, 0x6E, 0x67, 0x29
	};

	// ũ

	nFileSize = GetFileSize(hFile, NULL);

	hFileMap = CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
	if (hFileMap == NULL) return FALSE;

	pOffset = reinterpret_cast<LPBYTE>(MapViewOfFile(hFileMap, FILE_MAP_READ, 0, 0, 0));
	if (pOffset == NULL) {
		if (hFileMap != NULL) CloseHandle(hFileMap);

		return FALSE;
	}

	PIMAGE_DOS_HEADER pIDH = reinterpret_cast<PIMAGE_DOS_HEADER>(pOffset);

	// e_lfanew üũ
	if ((pIDH->e_lfanew <= 0) || (pIDH->e_lfanew > nFileSize)) {
		if (pOffset != NULL) UnmapViewOfFile(pOffset);
		if (hFileMap != NULL) CloseHandle(hFileMap);

		return FALSE;
	}

	PIMAGE_NT_HEADERS pINH = reinterpret_cast<PIMAGE_NT_HEADERS>(pOffset + pIDH->e_lfanew);

	// PE  üũ
	if (pINH->Signature != IMAGE_NT_SIGNATURE) {
		if (pOffset != NULL) UnmapViewOfFile(pOffset);
		if (hFileMap != NULL) CloseHandle(hFileMap);

		return FALSE;
	}

	// ù°  .
	PIMAGE_SECTION_HEADER pISH = reinterpret_cast<PIMAGE_SECTION_HEADER>(pOffset + (pIDH->e_lfanew)
																		+ sizeof(IMAGE_NT_SIGNATURE)
																		+ sizeof(IMAGE_FILE_HEADER)
																		+ pINH->FileHeader.SizeOfOptionalHeader);

	pCodeSectionOffset = pOffset + (pISH->PointerToRawData);
	nCodeSectionSize = pISH->SizeOfRawData;

	if (KMP_Match(VirPattern, sizeof(VirPattern), pCodeSectionOffset, nCodeSectionSize, pdwOffset) == TRUE) {
		*pdwOffset += pISH->PointerToRawData;

		if (pOffset != NULL) UnmapViewOfFile(pOffset);
		if (hFileMap != NULL) CloseHandle(hFileMap);

		return TRUE;
	}

	if (pOffset != NULL) UnmapViewOfFile(pOffset);
	if (hFileMap != NULL) CloseHandle(hFileMap);

	return FALSE;
}
//---------------------------------------------------------------------------
BOOL ScanThread::KMP_Match(LPBYTE pPattern, INT nPatternLength, LPBYTE pOffset, INT nSize, DWORD* pdwOffset)
{
	int i, j, kmpNext[80] = { 0, };

	// Preprocessing
	preKMP(pPattern, nPatternLength, kmpNext);

	// Searching
	i = j = 0;

	while (j < nSize) {
		while ((i > -1) && (*(pPattern + i) != *(pOffset + j)))
			i = kmpNext[i];

		i++, j++;
		if (i >= nPatternLength) {
			*pdwOffset = (j - i);

			return TRUE;
		}
	}

	return FALSE;
}
//---------------------------------------------------------------------------
void ScanThread::preKMP(LPBYTE pPattern, INT nPatternLength, int kmpNext[])
{
	int i, j;

	i = 0;
	j = kmpNext[0] = -1;

	while (i < nPatternLength) {
		while ((j > -1) && (*(pPattern + i) != *(pPattern + j)))
			j = kmpNext[j];

		i++, j++;

		if (*(pPattern + i) == *(pPattern + j))
			kmpNext[i] = kmpNext[j];
		else
			kmpNext[i] = j;
	}
}
